#ifndef PCL_FEATURES_H
#define PCL_FEATURES_H

#include <pcl/point_types.h>
#include <pcl/features/vfh.h>
#include <pcl/features/fpfh.h>
#include <pcl/features/normal_3d.h>
#include <pcl/common/centroid.h>
#include <Eigen/Eigen>

class NormalEstimation
{
  public:
    pcl::PointCloud<pcl::Normal>::Ptr normals_;

    void computeNormal (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud, double radius_search=0.03);
};

class Feature
{
  public:
    pcl::PointCloud<pcl::VFHSignature308>::Ptr descriptors_vfh;
    pcl::PointCloud<pcl::FPFHSignature33>::Ptr descriptors_fpfh;
    pcl::PointCloud<pcl::VFHSignature308>::Ptr descriptors_ovfh;

    void computeVFH (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud, double radius_search=0.03);
    void computeFPFH (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud, double radius_normal=0.03, double radius_fpfh=0.05);//radius_fpfh must bigger than radius_normal
    void computeOVFH (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud, double radius_search=0.03);
};
    

#endif

