#include <iostream>
#include <pcl/point_types.h>
#include <pcl/io/pcd_io.h>

#include<string>

#include "../include/PCLFeatures.h"
#include "../include/loadfile.h"

#define _DEBUG

int main(int argc, char * argv[])
{
    pcl::PointCloud<pcl::PointXYZ>::Ptr cloud (new pcl::PointCloud<pcl::PointXYZ>);

    Feature ovfh;

    Loadfile  lf;
    lf.loadfile(argv[1]);
    std::string add_part="_vfh";

    for(int i = 0; i < lf.filelists_.size(); ++i)
    {
        const char *filename = lf.filelists_[i].c_str();

        if (pcl::io::loadPCDFile<pcl::PointXYZ> (filename, *cloud) == -1) //* load the file
        {
          PCL_ERROR ("Couldn't read file *.pcd \n");
          return (-1);
        }

        ovfh.computeOVFH (cloud);

        std::string newName=lf.add_end( lf.filelists_[i],  add_part);//add add_part before "."
        newName=newName.substr(newName.find(argv[1])+strlen(argv[1]));
        std::string savepath=argv[2];
        newName = savepath+newName;
        const char *filename_out = newName.c_str();
#ifdef _DEBUG
        std::cout<<filename_out<<std::endl;
#endif // _DEBUG
        pcl::io::savePCDFileASCII(filename_out, *ovfh.descriptors_ovfh);

    }
    return 0;
}
