#ifndef PCL_FILTERS_H
#define PCL_FILTERS_H

#include <iostream>

#include <pcl/point_types.h>
#include <pcl/io/pcd_io.h>
#include <pcl/filters/impl/filter.hpp>
#include <pcl/filters/statistical_outlier_removal.h>
#include <pcl/filters/voxel_grid.h>
#include <pcl/filters/passthrough.h>
#include <pcl/ModelCoefficients.h>
#include <pcl/filters/project_inliers.h>

class RemoveNaN
{
  public:
    static void removeNaN (pcl::PointCloud<pcl::PointXYZ> &cloud_in, pcl::PointCloud<pcl::PointXYZ> &cloud_out);
};


class PassThroughFilter
{
  public:
    void filter (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud,
      pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud_filtered, char direction, double d1, double d2, bool outside=false);

};

class OutlierRemovalFilter
{
  public:
    void filter (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud,
      pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud_filtered, int mean_k,
      double std_dev_mul_thresh, bool flag_negative = false);

};

class VoxelGridFilter
{
  public:
    void filter (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud,
      pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud_filtered,
      double l1=0.01, double l2=0.01, double l3=0.01);
};

class PlaneProjecting
{
  public:
    void projecting (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud,
      pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud_projected,
      pcl::ModelCoefficients::Ptr &coefficients);
};

#endif
